%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2023 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& /Elements/Header, Title => loc("Ticket #[_1] Jumbo update: [_2]", $Ticket->Id, $Ticket->Subject) &>
<& /Elements/Tabs &>

% $m->callback(CallbackName => 'BeforeActionList', Actions => \@results, ARGSRef => \%ARGS, Ticket => $Ticket);
<& /Elements/ListActions, actions => \@results &>

<form method="post" action="ModifyAll.html" name="TicketModifyAll" enctype="multipart/form-data">
% $m->callback( CallbackName => 'FormStart', ARGSRef => \%ARGS );
<input type="submit" name="SubmitTicket" value="Save Changes" style="display:none">
<input type="hidden" class="hidden" name="id" value="<%$Ticket->Id%>" />
<input type="hidden" class="hidden" name="Token" value="<% $ARGS{'Token'} %>" />

<&| /Widgets/TitleBox, title => loc('Modify ticket # [_1]', $Ticket->Id), class=>'ticket-info-basics' &>
<& Elements/EditBasics, TicketObj => $Ticket, defaults => \%ARGS, ExcludeCustomRoles => 1 &>
<& /Elements/EditCustomFields, Object => $Ticket, Grouping => 'Basics' &>
</&>

% $m->callback(CallbackName => 'AfterBasics', Ticket => $Ticket);

<& /Elements/EditCustomFieldCustomGroupings, Object => $Ticket &>

<&| /Widgets/TitleBox, title => loc('Dates'), class=>'ticket-info-dates'&>
<& Elements/EditDates, TicketObj => $Ticket &>
</&>

<br />


<&| /Widgets/TitleBox, title => loc('People'), class=>'ticket-info-people' &>
<& Elements/EditPeople, Ticket => $Ticket, UserField => $UserField, UserString => $UserString, UserOp => $UserOp, GroupString => $GroupString, GroupOp => $GroupOp, GroupField => $GroupField &>
</&>

<br />

<&| /Widgets/TitleBox, title => loc('Links'), class=>'ticket-info-links' &>
<& /Elements/EditLinks, Object => $Ticket &>
</&>

<br />

<&| /Widgets/TitleBox, title => loc('Merge'), class=>'ticket-info-merge' &>
<& Elements/EditMerge, Ticket => $Ticket, %ARGS &>
</&>

<br />

<&| /Widgets/TitleBox, title => loc('Update ticket') &>
<table>
  <tr>
    <td class="label"><&|/l&>Update Type</&>:</td>
    <td class="entry">
      <select name="UpdateType" id="UpdateType">
% if ($CanComment) {
        <option value="private" ><&|/l&>Comments (Not sent to requestors)</&></option>
% }
% if ($CanRespond) {
        <option value="response"><&|/l&>Reply to requestors</&></option>
% }
      </select> 
% $m->callback( %ARGS, CallbackName => 'AfterUpdateType' );
    </td>
  </tr>
  <tr>
    <td class="label"><&|/l&>Subject</&>:</td>
    <td class="entry"><input name="UpdateSubject" size="60" value="<%$Ticket->Subject%>" />
% $m->callback( %ARGS, CallbackName => 'AfterSubject' );
    </td>
  </tr>

  <tr><td colspan="2"><& /Ticket/Elements/EditTransactionCustomFields, %ARGS, TicketObj => $Ticket &></td></tr>

<& /Ticket/Elements/AddAttachments, %ARGS, TicketObj => $Ticket &>

  <tr>
    <td class="labeltop"><&|/l&>Content</&>:</td>
    <td class="entry messagebox-container action-<% $ARGS{UpdateType} || ($CanComment ? 'private' : 'response') %>">
% $m->callback( %ARGS, CallbackName => 'BeforeMessageBox' );
% if (defined $ARGS{UpdateContent} && length($ARGS{UpdateContent})) {
    <& /Elements/MessageBox, Name=>"UpdateContent", Default=>$ARGS{UpdateContent}, IncludeSignature => 0 &>
% } else {
    <& /Elements/MessageBox, Name=>"UpdateContent", QuoteTransaction=>$ARGS{QuoteTransaction} &>
% }
  </td></tr>
</table>
</&>
  

<& /Elements/Submit, 
    Name    => 'SubmitTicket',
    Label   => loc('Save Changes'), 
    Caption => loc("If you've updated anything above, be sure to"), color => "#333399" &>
</form>

% $m->callback(CallbackName => 'AfterForm', ARGSRef => \%ARGS, Ticket => $Ticket);

<%INIT>



my $Ticket = LoadTicket($id);
my $CustomFields = $Ticket->CustomFields;

my $CanRespond = 0;
my $CanComment = 0;


$CanRespond = 1 if ( $Ticket->CurrentUserHasRight('ReplyToTicket') or
                     $Ticket->CurrentUserHasRight('ModifyTicket') ); 

$CanComment = 1 if ( $Ticket->CurrentUserHasRight('CommentOnTicket') or
                     $Ticket->CurrentUserHasRight('ModifyTicket') );

ProcessAttachments(ARGSRef => \%ARGS);

my @results;
my $skip_update = 0;
$m->callback( TicketObj => $Ticket, ARGSRef => \%ARGS, skip_update => \$skip_update, results => \@results );

{
    my ($status, @msg) = $m->comp(
        '/Elements/ValidateCustomFields',
        Object       => $Ticket,
        CustomFields => $CustomFields,
        ARGSRef      => \%ARGS,
    );
    unless ($status) {
        push @results, @msg;
        $skip_update = 1;
    }

    ( $status, @msg ) = PreprocessTimeUpdates( \%ARGS );
    unless ( $status ) {
        push @results, @msg;
        $skip_update = 1;
    }
}

# There might be two owners.
if ( ref ($ARGS{'Owner'} )) {
    my @owners =@{$ARGS{'Owner'}};
    delete $ARGS{'Owner'};
    foreach my $owner(@owners){
        if (defined($owner) && $owner =~ /\D/) {
            $ARGS{'Owner'} = $owner unless ($Ticket->OwnerObj->Name eq $owner);
        }
        elsif (length $owner) {
            $ARGS{'Owner'} = $owner unless ($Ticket->OwnerObj->id == $owner);
        }
    }
}

unless ($skip_update or $OnlySearchForPeople or $OnlySearchForGroup or $ARGS{'AddMoreAttach'} ) {
    $Ticket->Atomic(sub {
        push @results, ProcessTicketWatchers( TicketObj => $Ticket, ARGSRef => \%ARGS);
        push @results, ProcessObjectCustomFieldUpdates( Object => $Ticket, ARGSRef => \%ARGS);
        push @results, ProcessTicketDates( TicketObj => $Ticket, ARGSRef => \%ARGS);
        push @results, ProcessUpdateMessage( TicketObj => $Ticket, ARGSRef=>\%ARGS );
        push @results, ProcessTicketBasics( TicketObj => $Ticket, ARGSRef => \%ARGS );
        push @results, ProcessTicketLinks( TicketObj => $Ticket, ARGSRef => \%ARGS);
    });

    MaybeRedirectForResults(
        Actions   => \@results,
        Path      => "/Ticket/ModifyAll.html",
        Arguments => { id => $Ticket->id },
    );
}

# If they've gone and moved the ticket to somewhere they can't see, etc...
unless ($Ticket->CurrentUserHasRight('ShowTicket')) {
    if (@results) {
        Abort("A change was applied successfully, but you no longer have permissions to view the ticket", Actions => \@results);
    } else {
        Abort("No permission to view ticket");
    }
}

$Ticket->CurrentUser->AddRecentlyViewedTicket($Ticket);

</%INIT>



<%ARGS>
$OnlySearchForPeople => undef
$OnlySearchForGroup => undef
$UserField => undef
$UserOp => undef
$UserString => undef
$GroupString => undef
$GroupOp => undef
$GroupField => undef
$id => undef
</%ARGS>

